#include <sourcemod>
#pragma semicolon 1

new LaserCheck[MAXPLAYERS + 1] = 0;
new SilencerCheck[MAXPLAYERS + 1] = 0;

public Plugin:myinfo =
{
	name = "[L4D]Laser Sight & Silencer",
	description = "Open upgrades Laser Sight and Silencer",
	author = "Figa",
	version = "1.4",
	url = "http://fiksiki.3dn.ru"
};

public OnPluginStart()
{
	HookEvent("player_death", player_death, EventHookMode_Post);
	HookEvent("player_spawn", player_death, EventHookMode_Post);
	HookEvent("round_end", round_end, EventHookMode_Pre);
	HookEvent("round_start", round_end, EventHookMode_Pre);
	HookEvent("map_transition", round_end, EventHookMode_Pre);
	RegConsoleCmd("sm_silent", ToggleSilencer, "sm_silent - Toggle Silencer");
	RegConsoleCmd("sm_laser", ToggleLaser, "sm_laser - Toggle Laser Sight");
	LoadTranslations("l4d_lss.phrases");
}
public OnClientPostAdminCheck(client)
{
	ClientCommand(client, "bind l sm_laser; bind k sm_silent");
}

public Action:round_end(Handle:event, const String:name[], bool:dontBroadcast)
{
	for(new i=1; i<=MaxClients; i++)
	{
		if(IsClientInGame(i))
		{
			SetEntProp(i, Prop_Send, "m_upgradeBitVec", 0, 4);
			LaserCheck[i] = 0;
			SilencerCheck[i] = 0;
		}
	}
}
public Action:player_death(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(client > 0 && IsClientInGame(client) && GetClientTeam(client) == 2)
	{
		SetEntProp(client, Prop_Send, "m_upgradeBitVec", 0, 4);
		LaserCheck[client] = 0;
		SilencerCheck[client] = 0;
	}
}
public Action:ToggleSilencer(client, args)
{
	if (IsClientInGame(client) && !IsFakeClient(client) && GetClientTeam(client) == 2 && IsPlayerAlive(client))
	{
		new upgrades = GetEntProp(client, Prop_Send, "m_upgradeBitVec");
		if (SilencerCheck[client] == 0 && LaserCheck[client] == 1)
		{
			SetEntProp(client, Prop_Send, "m_upgradeBitVec", upgrades + 262144, 4);
			PrintToChat(client, "%t", "Silencer_On");
			SilencerCheck[client] = 1;
		}
		else if (SilencerCheck[client] == 0 && LaserCheck[client] == 0)
		{
			SetEntProp(client, Prop_Send, "m_upgradeBitVec", 262144, 4);
			PrintToChat(client, "%t", "Silencer_On");
			SilencerCheck[client] = 1;
		}
		else if (SilencerCheck[client] == 1 && LaserCheck[client] == 1)
		{
			SetEntProp(client, Prop_Send, "m_upgradeBitVec", upgrades - 262144, 4);
			PrintToChat(client, "%t", "Silencer_Off");
			SilencerCheck[client] = 0;
		}
		else if (SilencerCheck[client] == 1 && LaserCheck[client] == 0)
		{
			SetEntProp(client, Prop_Send, "m_upgradeBitVec", 0, 4);
			PrintToChat(client, "%t", "Silencer_Off");
			SilencerCheck[client] = 0;
		}
	}
	return Plugin_Handled;
}
public Action:ToggleLaser(client, args)
{
	if (IsClientInGame(client) && !IsFakeClient(client) && GetClientTeam(client) == 2 && IsPlayerAlive(client))
	{
		new upgrades = GetEntProp(client, Prop_Send, "m_upgradeBitVec");
		if (LaserCheck[client] == 0 && SilencerCheck[client] == 1)
		{
			SetEntProp(client, Prop_Send, "m_upgradeBitVec", upgrades + 131072, 4);
			PrintToChat(client, "%t", "Laser_On");
			LaserCheck[client] = 1;
		}
		else if (LaserCheck[client] == 0 && SilencerCheck[client] == 0)
		{
			SetEntProp(client, Prop_Send, "m_upgradeBitVec", 131072, 4);
			PrintToChat(client, "%t", "Laser_On");
			LaserCheck[client] = 1;
		}
		else if (LaserCheck[client] == 1 && SilencerCheck[client] == 1)
		{
			SetEntProp(client, Prop_Send, "m_upgradeBitVec", upgrades - 131072, 4);
			PrintToChat(client, "%t", "Laser_Off");
			LaserCheck[client] = 0;
		}
		else if (LaserCheck[client] == 1 && SilencerCheck[client] == 0)
		{
			SetEntProp(client, Prop_Send, "m_upgradeBitVec", 0, 4);
			PrintToChat(client, "%t", "Laser_Off");
			LaserCheck[client] = 0;
		}
	}
	return Plugin_Handled;
}